/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor original: T. Mercer-Hursh (thomas@cintegrity.com)
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Agrega los alias a los paquetes y componentes existentes.
- ENGLISH -
Adds alias to existing packages and components.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING PROGRESS.Lang.AppError.
USING com.nomadesoft.ABLaUML.FUWorker.
USING com.nomadesoft.lib.*.
USING com.nomadesoft.ABLaUML.repository.*.

/**
Se encarga de colocar cada unidad funcional (paquete) en el lugar que le corresponde.
**/
CLASS com.nomadesoft.ABLaUML.AliasWorker INHERITS FUWorker:

  DEFINE PRIVATE PROPERTY cchPath AS CHARACTER   NO-UNDO
    GET.
    SET.

  METHOD PROTECTED OVERRIDE VOID UnknownStart():
    IF cobParser:CurrentElement() NE 'alias' THEN /* slo me interesan los alias */
      cchPath = ?.
    ELSE
      cchPath = cobParser:AttributeValue('path').
  END METHOD.

  METHOD PROTECTED OVERRIDE VOID UnknownEnd():
    DEFINE VARIABLE minObjectID AS INTEGER     NO-UNDO.
    DEFINE VARIABLE mchPath AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE minPackID AS INTEGER     NO-UNDO.
      
    IF cchPath EQ ? THEN
      RETURN.

    /* intento encontrar la unidad funcional, si la encuentro tambin especifico su alias */
    mchPath = cchPath.
    IF ENTRY(2,mchPath,'.') EQ 'i' THEN /* inclusin */
      minObjectID = cobUtils:FindObject (
          INPUT "Component",
          input "nsInclude",
          input mchPath,
          ?
          ).           
    ELSE DO: /* programa o programa inicial */
      minObjectID = cobUtils:FindObject (
          INPUT "Component",
          input "nsInitialProgram",
          input mchPath,
          ?
          ).                  
      IF minObjectID EQ ? OR minObjectID EQ 0 THEN
        minObjectID = cobUtils:FindObject (
            INPUT "Component",
            input "nsProgram",
            input mchPath,
            ?
            ).                  
    END.
    if  minObjectID GT 0 THEN /* establecer los alias */
      cobUtils:AddObjectAlias(minObjectID,cobParser:ElementContent()).
    minObjectID = 0.
  
    IF mchPath MATCHES  cchClasifMatch THEN /* unidad funcional de clasificadores */
      minObjectID = cobUtils:FindObject(
        input "Component",
        input "nsFunctionalUnit",
        input mchPath,
        ?
        ).
    ELSE IF mchPath MATCHES cchLibMatch THEN DO: /* unidad funcional de nslib, puede ser inclusin o programa */
      minObjectID = cobUtils:FindObject(
        input "Component",
        input "nsLibInclude",
        input mchPath,
        ?
        ).
      IF minObjectID EQ ? OR minObjectID EQ 0 THEN
        minObjectID = cobUtils:FindObject(
          input "Component",
          input "nsLibProgram",
          input mchPath,
          ?
          ).
    END.
    ELSE DO:  /* unidad funcional del proyecto */
      mchPath = ENTRY(1,mchPath,'.').
      minObjectID = cobUtils:FindPackage (
        input mchPath,
        ?
        ).                  
      if  minObjectID NE ? AND minObjectID NE 0 then
        cobUtils:AddPackageAlias(minObjectID,cobParser:ElementContent()).
      minObjectID = 0.
    END.
    if  minObjectID GT 0 THEN /* establecer los alias */
      cobUtils:AddObjectAlias(minObjectID,cobParser:ElementContent()).
    CATCH pError AS Progress.Lang.Error:
      DELETE OBJECT pError. /* ignorar los errores, no son importantes */
    END CATCH.
  END METHOD.

  CONSTRUCTOR AliasWorker(INPUT ipobUtils AS CLASS IUtils):
    SUPER(ipobUtils).
  END CONSTRUCTOR.
END CLASS.
