/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor original: T. Mercer-Hursh (thomas@cintegrity.com)
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Agrega las notas a los paquetes y componentes existentes.
- ENGLISH -
Adds notes to existing packages and components.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING PROGRESS.Lang.AppError.
USING com.nomadesoft.ABLaUML.FUWorker.
USING com.nomadesoft.lib.*.
USING com.nomadesoft.ABLaUML.repository.*.

/**
Se encarga de colocar cada unidad funcional (paquete) en el lugar que le corresponde.
**/
CLASS com.nomadesoft.ABLaUML.NotasWorker INHERITS FUWorker:

  DEFINE PRIVATE PROPERTY cchPath AS CHARACTER NO-UNDO
    GET.
    SET.
  DEFINE PRIVATE PROPERTY cchComponent AS CHARACTER NO-UNDO
    GET.
    SET.
    
  METHOD PROTECTED OVERRIDE VOID UnknownStart():
    cchPath = cobParser:AttributeValue('fu').
    cchComponent = cobParser:AttributeValue('component').
  END METHOD.
  
  METHOD PROTECTED OVERRIDE VOID UnknownEnd():
    DEFINE VARIABLE minObjectID AS INTEGER     NO-UNDO.
    DEFINE VARIABLE mchPath AS CHARACTER   NO-UNDO.
    DEFINE VARIABLE minPackID AS INTEGER     NO-UNDO.
      
    mchPath = cchPath.
    IF mchPath NE '' THEN DO: /* es una unidad funcional */
      IF mchPath MATCHES  cchClasifMatch THEN DO: /* unidad funcional de clasificadores */
        IF cchComponent NE ? AND cchComponent NE '' THEN
          mchPath = cchComponent.
        minObjectID = cobUtils:FindObject(
          input "Component",
          input "nsFunctionalUnit",
          input mchPath,
          ?
          ).
      END.
      ELSE IF mchPath MATCHES cchLibMatch THEN DO: /* unidad funcional de nslib, puede ser inclusin o programa */
        IF cchComponent NE ? AND cchComponent NE '' THEN
          mchPath = cchComponent.
        minObjectID = cobUtils:FindObject(
          input "Component",
          input "nsLibInclude",
          input mchPath,
          ?
          ).
        IF minObjectID EQ ? OR minObjectID EQ 0 THEN
          minObjectID = cobUtils:FindObject(
            input "Component",
            input "nsLibProgram",
            input mchPath,
            ?
            ).
      END.
      ELSE DO:  /* unidad funcional del proyecto */
        minObjectID = cobUtils:FindPackage (
          input mchPath,
          ?
          ).                  
        if  minObjectID NE ? AND minObjectID NE 0 then
          cobUtils:AddPackageNotes(minObjectID,cobParser:ElementContent()).
        RETURN.
      END.
    END.
    ELSE DO:
      /* encontrar la unidad funcional a la que pertenece */
      minPackID = cobUtils:FindPackage(
          cobParser:AttributeValue('fu'),
          ?
          ).
      IF ENTRY(2,mchPath,'.') EQ 'i' THEN /* inclusin */
        minObjectID = cobUtils:FindObject (
            INPUT "Component",
            input "nsInclude",
            input mchPath,
            minPackID
            ).           
      ELSE DO: /* programa o programa inicial */
        minObjectID = cobUtils:FindObject (
            INPUT "Component",
            input "nsInitialProgram",
            input mchPath,
            minPackID
            ).                  
        IF minObjectID EQ ? OR minObjectID EQ 0 THEN
          minObjectID = cobUtils:FindObject (
              INPUT "Component",
              input "nsProgram",
              input mchPath,
              minPackId
              ).                  
      END.
    END.
    if  minObjectID eq ? or minObjectID eq 0 then
      RETURN.
    /* establecer las notas */
    cobUtils:AddObjectNotes(minObjectID,cobParser:ElementContent()).

    CATCH pError AS Progress.Lang.Error:
      DELETE OBJECT pError. /* ignorar los errores, no son importantes */
    END CATCH.
  END METHOD.

  CONSTRUCTOR NotasWorker(INPUT ipobUtils AS CLASS IUtils):
    SUPER(ipobUtils).
  END CONSTRUCTOR.
END CLASS.
