/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Clase para el mapeo de estereotipos, la propiedad cchMap es una lista
de mapeo.
- ENGLISH -
Stereotype mapping class. cchMap is a list of mappings.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

USING PROGRESS.Lang.AppError.
USING com.nomadesoft.lib.*.

CLASS com.nomadesoft.ABLaUML.StMapper IMPLEMENTS IMapper:
  DEFINE PUBLIC PROPERTY cchMap AS CHARACTER NO-UNDO
    GET.
    SET.

  METHOD PUBLIC CHARACTER MapIt(input  ipchMapped as character, INPUT iplgReverse AS LOGICAL).
    DEFINE VARIABLE minIndex AS INTEGER     NO-UNDO.
    DEFINE VARIABLE minDelta AS INTEGER     NO-UNDO.
    DEFINE VARIABLE mchEntry AS CHARACTER   NO-UNDO.

    IF iplgReverse THEN ASSIGN
      minIndex = 2
      minDelta = -1
      .
    ELSE ASSIGN
      minIndex = 1
      minDelta = 1
      .

    DO WHILE minIndex <= NUM-ENTRIES(cchMap):
      mchEntry = ENTRY(minIndex,cchMap).
      IF  mchEntry EQ ipchMapped THEN
        RETURN ENTRY(minIndex + minDelta,cchMap).
      minIndex = minIndex + 2.
    END.
    RETURN ipchmapped.
  END METHOD.

  METHOD PUBLIC INTEGER MapIt(input  ipinMapped as INTEGER, INPUT iplgReverse AS LOGICAL).
    RETURN ipinmapped.
  END METHOD.

  METHOD PUBLIC DATETIME MapIt(INPUT ipdtMapped AS DATETIME, INPUT iplgReverse AS LOGICAL).
    RETURN ipdtmapped.
  END METHOD.
END CLASS.
