/*****************
Propiedad intelectual de NmadeSoft SRL (info@nomadesoft.com.ar)
---
autor: D. Abdala (dabdala@nomadesoft.com.ar)
ltima modificacin: 2010-06-01
---
Interfaz de modelado. Permite la manipulacin de los diferentes elementos
que conforman el modelo UML.
- ENGLISH -
Modeling interface. Manipulation of UML model objects.
*****************/
ROUTINE-LEVEL ON ERROR UNDO, THROW.

/* interfaz para la manipulacin del repositorio UML */
INTERFACE com.nomadesoft.ABLaUML.repository.IUtils:
  /* manipulacin de paquetes */
  METHOD PUBLIC LOGICAL AddPackageNotes(input  ipinPackageID as INTEGER,input  ipchNotes as CHARACTER).
  METHOD PUBLIC LOGICAL AddPackageAlias(input  ipinPackageID as INTEGER,input  ipchAlias as CHARACTER).
  METHOD PUBLIC INTEGER CreatePackage(input  ipchPackageName as character,input  ipinParentPackageID as integer).
  METHOD PUBLIC INTEGER CreateModelPackage(input  ipchPackageName as character, input  ipinParentPackageID as INTEGER, INPUT ipinTipo AS INTEGER).
  METHOD PUBLIC VOID MovePackage(INPUT ipchPackageName AS CHARACTER, INPUT ipinParentPackageID as integer, input  ipinNewParentPackageID as INTEGER).
  METHOD PUBLIC INTEGER PackageParent(INPUT ipchPackageName AS CHARACTER).
  METHOD PUBLIC INTEGER FindPackage(input  ipchPackageName as character, input  ipinParentPackageID as INTEGER).
  METHOD PUBLIC INTEGER FindPackage(input  ipchPackageName as character, input  ipinParentPackageID as INTEGER, INPUT iplgRealChild AS LOGICAL).
  METHOD PUBLIC LOGICAL SetPackageName(INPUT ipinPackageId AS INTEGER,INPUT ipchNewName AS CHARACTER).
  METHOD PUBLIC LOGICAL DeletePackage(INPUT ipinPackageId AS INTEGER,INPUT iplgObjectToo AS LOGICAL).
  /* manipulacin de objetos */
  METHOD PUBLIC LOGICAL AddObjectNotes(input  ipinObjectID as INTEGER,input  ipchNotes as character).
  METHOD PUBLIC LOGICAL AddObjectAlias(input  ipinObjectID as INTEGER,input  ipchAlias as CHARACTER).
  METHOD PUBLIC INTEGER CreateObject(input  ipchObjectType as character,input  ipchObjectName as character,input  ipinPackageID as INTEGER, input  ipinParentID as INTEGER,input  ipchStereotype as character,input  ipchNotes as CHARACTER,input ipchAlias as CHARACTER).
  METHOD PUBLIC INTEGER FindObject(input  ipchObjectType as character,input ipchStereotype as character,input  ipchObjectName as character,INPUT ipinPackageID AS INTEGER).
  METHOD PUBLIC INTEGER SetObjectTag(input  ipinObjectID as integer,input  ipchProperty as CHARACTER,input  ipchValue as CHARACTER).
  METHOD PUBLIC LOGICAL SetObjectName(INPUT ipinObjectId AS INTEGER,INPUT ipchNewName AS CHARACTER).
  METHOD PUBLIC LOGICAL SetObjectType(INPUT ipinObjectId AS INTEGER,INPUT ipchNewType AS CHARACTER).
  METHOD PUBLIC VOID MoveObject(INPUT ipinObjectID AS INTEGER, input  ipinNewParentPackageID as INTEGER):
  METHOD PUBLIC INTEGER CreateAttribute(input ipinObjectID as INTEGER,input ipchObjectName as character,input ipchStereotype as character,input ipchNotes as character ,input ipinPos as INTEGER,input ipinNotNull as integer,input ipchDefault as character,input ipchDataType as CHARACTER,input ipchAttributeType as CHARACTER).
  METHOD PUBLIC INTEGER SetAttributeTag(input  ipinAttributeID as INTEGER,input  ipchProperty as character,input  ipchValue as character).
  METHOD PUBLIC LOGICAL SetAttributeAlias(input  ipinAttributeID as INTEGER,input  ipchAlias AS CHARACTER).
  /* relaciones */
  METHOD PUBLIC INTEGER CreateConnector(input  ipchConnectorType as character,input  ipchSourceCardinality as character,input  ipchDestinationCardinality as CHARACTER,input  ipchSourceRole as character,input  ipchDestinationRole as CHARACTER,input  ipinStartObjectID as INTEGER,input  ipinEndObjectID as integer,input  ipchStereotype as CHARACTER,INPUT iplgForce AS LOGICAL). /* se puede forzar la creacin de conectores en apariencia duplicados */
  METHOD PUBLIC CHARACTER SetConnectorAlias(INPUT ipchConnectorID AS INTEGER, INPUT ipchAlias AS CHARACTER).
  METHOD PUBLIC INTEGER SetConnectorTag(input  ipinConnectorID as integer,input  ipchProperty as character,input  ipchValue as character).
  /* manipulacin de diagramas */
  METHOD PUBLIC INTEGER CreateDiagram(input  ipinPackageID as INTEGER,input  ipchName as CHARACTER, INPUT ipchType AS CHARACTER).
  METHOD PUBLIC INTEGER AddDiagramObject(input  ipinDiagramID as INTEGER,input  ipinObjectID as INTEGER,INPUT ipchStyle AS CHARACTER, INPUT iplgHideRelations AS LOGICAL). /* oculta todos los conectores */
  METHOD PUBLIC VOID HideDiagramRelations(INPUT ipinDiagramID AS INTEGER,INPUT ipinObjectID AS INTEGER). /* oculta todas las relaciones para las cuales el objeto es el origen, si ambos extremos son parte del diagrama */
  METHOD PUBLIC LOGICAL ShowDiagramConnector(INPUT ipinDiagramID AS integer, INPUT ipinStartID AS INTEGER, INPUT ipinEndID AS INTEGER, INPUT ipchAlias AS CHARACTER). /* muestra un conector */
  METHOD PUBLIC LOGICAL SetDiagramName(input  ipinPackageID as INTEGER,input  ipchName as CHARACTER, INPUT ipchNewName AS CHARACTER).
  METHOD PUBLIC LOGICAL DeleteDiagram(input  ipinPackageID as INTEGER,input  ipchName as CHARACTER).
  METHOD PUBLIC INTEGER MoveDiagram(input  ipinPackageID as INTEGER,input  ipchName as CHARACTER, INPUT ipchNewPackage AS INTEGER).
  METHOD PUBLIC INTEGER FindDiagram(input  ipinPackageID as INTEGER,input  ipchName as CHARACTER).
  /* manipulacin del modelo de datos */
 METHOD PUBLIC INTEGER SetDataLink(input ipinStartObjectID as INTEGER,input ipinEndObjectID as INTEGER,input iplgHasCreate as LOGICAL,input iplgHasRead as logical,input iplgHasUpdate as LOGICAL,input iplgHasDelete as logical,input iplgIsSummary as LOGICAL, INPUT ipchConnAlias AS CHARACTER).
 METHOD PUBLIC INTEGER DataLinkCount(input ipinObjectID as INTEGER).
 METHOD PUBLIC INTEGER CreateOperation(input  ipinObjectID as INTEGER,input  ipchOperationName as CHARACTER,input  ipchStereotype as CHARACTER).
 METHOD PUBLIC VOID CreateOperationParam(input  ipinOperationID as integer, input  ipchName as character, input  ipchType as character, input  ipchDefault as character,input  ipinPos as integer, input  ipchKind as character,input  ipchStereotype as CHARACTER).
 METHOD PUBLIC VOID CreateOperationPost(input  ipinOperationID as INTEGER, input  ipchCondition as character, input  ipchType as CHARACTER).
 METHOD PUBLIC INTEGER SetOperationTag(input  ipinOperationID as integer,input  ipchProperty as character,input  ipchValue as CHARACTER).
 /* general */
 METHOD PUBLIC VOID CleanIt().
END INTERFACE.
